/*
 * xmlstack -- elf x86 executable call stack tracing application
 * 5/11/2002
 *
 * Please refer to the README file for credit and distribution information.
 */

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

#include "xmlstack.h"

#include "libdis.h"

int main(int argc, char **argv)
{
	extern char *optarg;
	XMLSTACK_INSTANCE xsi;
	int c;

	memset(&xsi, 0, sizeof(xsi));

	while ((c = getopt(argc,argv,"b:x:hovdpcnwf:")) != EOF)
	{
		switch (c)
		{
			case 'b':
				xsi.binaryFile = optarg;
				break;
			case 'x':
				xsi.xmlFile = optarg;
				break;
			case 'o':
				xsi.flags |= XMLSTACK_FLAG_NOTEXECUTABLE;
				break;
			case 'v':
				xsi.flags |= XMLSTACK_FLAG_VERBOSE;
				break;
			case 'd':
				xsi.flags |= XMLSTACK_FLAG_DBGSYMS;
				break;
			case 'p':
				xsi.flags |= XMLSTACK_FLAG_PRECACHEDBGSYMS;
				break;
			case 'c':
				xsi.flags |= XMLSTACK_FLAG_CLEANUP;
				break;
			case 'n':
				xsi.flags |= XMLSTACK_FLAG_DONTREPEATSTK;
				break;
			case 'w':
				xsi.flags |= XMLSTACK_FLAG_WRITEASYOUGO;
				break;
			case 'f':
				xsi.filterFunctions = optarg;
				break;
			case 'h':
				fprintf(stdout,"xmlstack version 1.00 5/12/2002 skape mmiller@hick.org http://www.uninformed.org\n");
				fprintf(stdout,"Usage: %s [OPTIONS...] -b binary -x output_xml\n",argv[0]);
				fprintf(stdout," OPTIONS\n");
				fprintf(stdout,"   -h      help\n");
				fprintf(stdout,"   -o      object file, not executable (DEFAULT=no)\n");
				fprintf(stdout,"   -d      lookup debug symbols (DEFAULT=no)\n");
				fprintf(stdout,"   -p      pre-cache debug symbols (increases lookup speed, DEFAULT=no)\n");
				fprintf(stdout,"   -c      make xmlstack clean up resources once finished. (DEFAULT=no)\n");
				fprintf(stdout,"   -n      don't repeat full stack if a function is called more than once per child. (DEFAULT=no)\n");
				fprintf(stdout,"   -w      write as you go.  this makes memory usage *much* less, but disables filtering. (DEFAULT=no)\n");
				fprintf(stdout,"   -f [..] filter for certain functions (seperated by commas).\n");
				return 0;
			default:
				break;
		}
	}

	if (!xsi.binaryFile)
	{
		fprintf(stdout,"FATAL: No binary was specified. (-b binary)\n");
		return 0;
	}

	disassemble_init(0, INTEL_SYNTAX);

	if (binaryProcess(&xsi) <= 0)
	{
		fprintf(stdout,"FATAL: binaryProcess() failed.\n");

		disassemble_cleanup();

		return 0;
	}

	disassemble_cleanup();

	return 1;
}
