/*
 * xmlstack -- elf x86 executable call stack tracing application
 * 5/11/2002
 *
 * Please refer to the README file for credit and distribution information.
 */
#ifndef _XMLSTACK_H
#define _XMLSTACK_H

#include "domass.h"
#include "hash.h"

#define XMLSTACK_FLAG_NOTEXECUTABLE			(1 << 0)
#define XMLSTACK_FLAG_VERBOSE					(1 << 1)
#define XMLSTACK_FLAG_DBGSYMS					(1 << 2)
#define XMLSTACK_FLAG_PRECACHEDBGSYMS		(1 << 3)
#define XMLSTACK_FLAG_CLEANUP					(1 << 4)
#define XMLSTACK_FLAG_DONTREPEATSTK			(1 << 5)
#define XMLSTACK_FLAG_WRITEASYOUGO			(1 << 6)

typedef struct _xmlstack_instance {

	int flags;

	char *binaryFile;			/* Binary image file */
	char *xmlFile;				/* XML output file (null means stdout) */
	char *filterFunctions;	/* Filter functions list, seperated by commas */

	FILE *writeAsYouGoFd;	/* Fd to use if writing as we go. */

	DOM_Element *rootElement;

	HASH_GROUP   dbgSymHash;		/* hash of Elf32_Symbol_Debug's */

} XMLSTACK_INSTANCE;

#define SYMBOL_TYPE_STATIC		0x01
#define SYMBOL_TYPE_DYNAMIC	0x02

int binaryProcess(XMLSTACK_INSTANCE *xsi);

#endif
